##############################################################################
#
# Cookie Auth
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: adapter.py,v 1.4 2005/10/25 15:27:19 dreamcatcher Exp $
"""

from zope.interface import implements
from cookieauth.interfaces import ICookieLoginPassword
from zope.app.security.basicauthadapter import BasicAuthAdapter

class CookieAuthAdapter(BasicAuthAdapter):

    implements(ICookieLoginPassword)

    def __init__(self, request):
        BasicAuthAdapter.__init__(self, request)
        self._request = request
        request.form['template_name'] = 'unauthorized.pt'

    def getLogin(self):
        request = self._request

        has_cookie = True
        username = request.cookies.get('__z3_user', None)
        if username is None:
            has_cookie = False
            username = request.form.get('__z3_user', None)
        if username is not None and not has_cookie:
            request.response.setCookie(
                '__z3_user'
                , username
                , path='/'
                )
        if username is None:
            return BasicAuthAdapter.getLogin(self)
        return username

    def getPassword(self):
        request = self._request
        has_cookie = True
        password = request.cookies.get('__z3_pass', None)
        if password is None:
            has_cookie = False
            password = request.form.get('__z3_pass', None)
        if password is not None and not has_cookie:
            request.response.setCookie(
                '__z3_pass'
                , password
                , path='/'
                )
        if password is None:
            return BasicAuthAdapter.getPassword(self)
        return password

    def needLogin(self, realm):
        pass
