##############################################################################
#
# Cookie Auth
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: logout.py,v 1.3 2005/10/21 01:47:55 dreamcatcher Exp $
"""

from zope.interface import implements
from zope.app import zapi
from zope.app.publisher.interfaces.http import ILogout
from zope.app.pagetemplate import ViewPageTemplateFile

class CookieAuthLogout(object):

    implements(ILogout)

    def __init__(self, context, request):
        self.context = context
        self.request = request

    def logout(self):
        request = self.request
        response = request.response
        response.expireCookie('__z3_user'
                              , path='/'
                              )
        response.expireCookie('__z3_pass'
                              , path='/'
                              )
        return response.redirect('/@@logged_out.html')

    confirmation = ViewPageTemplateFile('logout.pt')
