##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: absoluteurl.py,v 1.2 2005/10/21 00:08:11 dreamcatcher Exp $
"""

from zope.app import zapi
from zope.app.traversing.browser.absoluteurl import AbsoluteURL as AbsURL, \
     _insufficientContext
from zope.proxy import sameProxiedObjects
from sip.interfaces import INoopBreadcrumb, IAppRoot, INolinkBreadcrumb
from sip.interfaces.container import IContainer

class AbsoluteURL(AbsURL):

    def breadcrumbs(self):

        context = self.context
        request = self.request

        # We do this here do maintain the rule that we must be wrapped
        container = getattr(context, '__parent__', None)
        if container is None:
            raise TypeError, _insufficientContext

        if sameProxiedObjects(context, request.getVirtualHostRoot()) or \
               isinstance(context, Exception):
            if IAppRoot.providedBy(context):
                return ({'name':context.__name__,
                        'title':'Project Listing',
                        'url': self.request.getApplicationURL()}, )
            return ({'name':'', 'url': self.request.getApplicationURL()}, )

        base = tuple(zapi.getView(container,
                                  'absolute_url', request).breadcrumbs())

        name = getattr(context, '__name__', None)
        if name is None:
            raise TypeError, _insufficientContext

        if (INoopBreadcrumb.providedBy(context) or
            (IContainer.providedBy(context)
             and context.parent_id == 0)):
            base += ({'name': '',
                      'title': '',
                      'url': ("%s/%s" % (base[-1]['url'], name))
                      }, )
        elif name:
            if IAppRoot.providedBy(context):
                title = 'Project Listing'
            else:
                title = getattr(context, 'name', name)
            if title in ('+', 'schema'):
                title = name = ''
            if INolinkBreadcrumb.providedBy(context):
                url = ''
            else:
                url = "%s/%s" % (base[-1]['url'], name)
            base += ({'name': name,
                      'title': title,
                      'url': url
                      }, )
        return base
