##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: contents.py,v 1.2 2005/10/21 00:08:11 dreamcatcher Exp $
"""

from zope.component import ComponentLookupError

from zope.app.container.browser.contents import Contents as BaseContents
from zope.app.pagetemplate.viewpagetemplatefile import ViewPageTemplateFile
from zope.app.container.interfaces import IReadContainer

from sip.interfaces.location import ILocation
from sip.interfaces.container import IContainer

class Contents(BaseContents):

    def __init__(self, context, request):
        context = IReadContainer(context)
        super(Contents, self).__init__(context, request)

    normalButtons = True
    specialButtons = False
    supportsRename = False
    supportsCut = False
    supportsPaste = False
    supportsCopy = False

    def _normalListContentsInfo(self):
        try:
            info = super(Contents, self)._normalListContentsInfo()
        except ComponentLookupError:
            info = map(self._extractContentInfo,
                       IReadContainer(self.context).items())
        return info

    def _extractContentInfo(self, item):
        id, obj = item

        info = super(Contents, self)._extractContentInfo(item)

        info['name'] = getattr(obj, 'name', id)
        return info


    def hasClipboardContents(self):
        """ interogates the PrinicipalAnnotation to see if
           clipboard contents exist """
        return False

    def canAddContainer(self):
        """checks to see if we are in a place where we can add containers"""
        context = self.context
        return IContainer.providedBy(context) \
               or ILocation.providedBy(context)

    contents = ViewPageTemplateFile('contents.pt')
