##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: confirm.py,v 1.2 2005/10/21 00:08:11 dreamcatcher Exp $
"""

from sip.browser import api
from zope.app.publisher.browser import BrowserView
from zope.app.content_types import find_binary

class CSVConfirmView(BrowserView):

    def _doImport(self, dry_run=True):
        request = self.request
        context = self.context
        project = api.getProject(context)
        importfile = request.get('importfile')
        self.tid = tid = request.get('tid')
        self.template = template = request.get('template')
        data = None
        if importfile is not None:
            data = importfile.read()
            if find_binary(data) is not None:
                self.results = ('Uploaded file is binary. '
                                'Please upload a text csv file.')
                return
            data = '\n'.join(data.splitlines())
        if importfile and not data:
            self.results = ('No file has been uploaded. ')
            return
        proc, self.template = api.lookupProcessor(data=data,
                                             template=template)
        self.results, self.tid = proc(context=context,
                                 data=data,
                                 tid=tid,
                                 dry_run=dry_run,
                                 request=request)


    def tryImport(self):
        return self._doImport(dry_run=True)

    def finishImport(self):
        return self._doImport(dry_run=False)
