##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: add.py,v 1.2 2005/10/21 00:08:12 dreamcatcher Exp $
"""
from zope.app.form.browser.add import AddView as BaseAddView
from sip.browser import api

class AddView(BaseAddView):

    def __init__(self, *args, **kw):
        super(AddView, self).__init__(*args, **kw)
        project = api.queryProject(self.context.context)
        # Commit message should never be asked when
        # adding objects.
        filter_out = ['commit_message']
        f = lambda x: x not in filter_out
        self.fieldNames = filter(f, self.fieldNames)

    def createAndAdd(self, data):
        request = self.request
        if not data.get('commit_message'):
            project = api.queryProject(self.context.context)
            user = request.principal
            msg = u"Added by '%s'" % (user and user.getLogin()
                                      or '<unknown user>')
            data['commit_message'] = msg
        return super(AddView, self).createAndAdd(data)
