##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: tree_views.py,v 1.2 2005/10/21 00:08:11 dreamcatcher Exp $
"""

from zope.app.tree.browser.cookie import CookieTreeView
from zope.app.tree.filters import OnlyInterfacesFilter
from zope.app.publisher.browser import BrowserView

from sip.shipment.interfaces import IShipment, IOutgoingShipmentState
from sip.interfaces.location import ILocation
from sip.interfaces.container import IContainer
from sip.interfaces.source import ILocationProjectSource
from sip.interfaces.location_project import ILocationProject
from sip.browser import api
from sip import File

class ContainerTreeView(CookieTreeView):

    def canAdd(self):
        return api.checkSIPPermission(self.context, 'sip.AddContainer')

    def cookieTree(self, root=None, filter=None):
        if filter is None:
            filter = OnlyInterfacesFilter(ILocationProject,
                                          IContainer,
                                          ILocationProjectSource,
                                          ILocation,
                                          IShipment,
                                          IOutgoingShipmentState)

        return super(ContainerTreeView, self).cookieTree(
            root=root, filter=filter)


class ModifyContainersCSV(BrowserView):

    modify_containers = File('csv/templates/modify_containers.csv')

    def getCSV(self):
        request = self.request
        context = self.context
        response = request.response
        response.setHeader('content-type', 'application/x-csv')
        response.setHeader('content-disposition',
                               'attachment; filename=modify_containers.csv')
        container_ids = request.get('container_ids', [])
        template = '%s,\r\n'
        data = {}
        data['containers'] = ''
        for id in container_ids:
            path = api.getContainerPathFromId(context, id)
            data['containers'] += template % path
        return str(self.modify_containers) % data
