##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: file.py,v 1.2 2005/10/21 00:11:35 dreamcatcher Exp $
"""

from cPickle import dumps, loads
from os import curdir, remove
from os.path import abspath, dirname, join, exists
from sip.csv.storage.common import Storage
from sip.csv.storage.exceptions import StorageError

try:
    __file__
except NameError:
    # Called directly, so no __file__ global exists.
    _prefix = abspath(curdir)
else:
    # Called by another script.
    _prefix = abspath(dirname(__file__))


class FileStorage(Storage):

    def _getfname(self, tid):
        return join(_prefix, 'tmp', '%s.csv' % tid)

    def store(self, context, data, tid):
        fname = self._getfname(tid)
        f = open(fname, 'w')
        f.write(dumps(data))
        f.close()

    def load(self, context, tid):
        fname = self._getfname(tid)
        try:
            f = open(fname, 'r')
        except (IOError, OSError):
            raise StorageError, 'Invalid transaction id #%s' % tid
        data = loads(f.read())
        f.close()
        return data

    def expire(self, context, tid):
        fname = self._getfname(tid)
        try:
            remove(fname)
        except (IOError, OSError), msg:
            raise StorageError, 'Invalid transaction id #%s' % tid
