##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
__metaclass__ = type

from pprint import pformat

class MassagerTraceback:

    def __init__(self, row, section, offset=None, template=None, table=None):
        self.row = row
        self.section = section
        self.offset = offset
        self.template = template
        self.table = table

    def getInfo(self):
        result = []
        if self.template is not None:
            result.append('  - template: %s' % self.template)
        if self.section is not None:
            result.append('  - section: %s' % self.section)
        if self.offset is not None:
            result.append('  - offset: %s' % self.offset)
        if self.table is not None:
            result.append('  - section length: %s' % len(self.table))
        result.append(pformat(self.row))
        return "\n".join(result)

class ProcessorTraceback:

    def __init__(self, row, section, offset=None):
        self.row = row
        self.section = section
        self.offset = offset

    def getInfo(self):
        result = []
        if self.section is not None:
            result.append('  - section: %s' % self.section)
        if self.offset is not None:
            result.append('  - offset: %s' % self.offset)
        result.append(pformat(self.row))
        return "\n".join(result)
