##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: exceptions.py,v 1.2 2005/10/21 00:11:35 dreamcatcher Exp $
"""

import sys
import traceback
from types import StringTypes

from zope.exceptions.exceptionformatter import format_exception
from zope.interface.common.interfaces import IException

__metaclass__ = type


class ExceptionDebugView:
    """ Render exceptions for debugging."""
    __used_for__ = IException

    def __init__(self, context, request):

        self.context = context
        self.request = request

        self.error_type, self.error_object, tb = info = sys.exc_info()

        try:
            strtype = str(getattr(info[0], '__name__', info[0]))

            if not isinstance(info[2], StringTypes):
                self.tb_text = ''.join(
                        format_exception(*info, **{'as_html': 0}))
                self.tb_html = ''.join(
                    format_exception(*info, **{'as_html': 1}))
            else:
                self.tb_text = info[2]
        except:
            try:
                self.tb_lines = traceback.format_tb(tb)
            finally:
                del tb

        info = None
