##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: test_absurl.py,v 1.2 2005/10/21 00:11:35 dreamcatcher Exp $
"""

import unittest

from zope.app import zapi
from zope.app.container.interfaces import IReadContainer
from sip.browser import api
from sip.ftests.base import Base

class TestAbsURL(Base):
    level = 2
    use_test_user = False

    def testRootAbsURL(self):
        absolute_url = zapi.getView(self.sip, 'absolute_url', self.request)
        self.failUnless(absolute_url())
        self.failUnless(absolute_url.breadcrumbs())

    def testObjectAbsURL(self):
        project = self._addProject()
        absolute_url = zapi.getView(project, 'absolute_url', self.request)
        self.failUnless(absolute_url())
        self.failUnless(absolute_url.breadcrumbs())

    def testSchemaAbsURL(self):
        project = self._addProject()
        stype = self._addSampleType(project)
        schema = api.getSchemaFor(stype.id, project)
        absolute_url = zapi.getView(schema, 'absolute_url', self.request)
        self.failUnless(absolute_url())
        self.failUnless(absolute_url.breadcrumbs())

def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TestAbsURL))
    return suite

if __name__ == '__main__':
    unittest.main()
