##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: test_labtechnicianrole.py,v 1.2 2005/10/21 00:11:35 dreamcatcher Exp $
"""

import unittest

from zope.app import zapi
from zope.app.servicenames import Authentication
from zope.exceptions import ForbiddenAttribute, Unauthorized
from sip.ftests.test_reportrole import TestReportRole
from sip.ftests.test_reportrole import TestSQLRole

class TestLabTechRole(TestReportRole):

    _roles = ['sip.Report', 'sip.LabTechnician']
    _principal = 'sip.lab_technician'

    def testAddSample(self):
        view = self._roleAddSample()
        self.failUnless(view())

    def testEditSample(self):
        view = self._roleEditSample()
        self.failUnless(view())

class TestSQLLabTechRole(TestSQLRole, TestLabTechRole): pass

def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TestLabTechRole))
    suite.addTest(unittest.makeSuite(TestSQLLabTechRole))
    return suite

if __name__ == '__main__':
    unittest.main()
