##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: test_principalmanage.py,v 1.2 2005/10/21 00:11:35 dreamcatcher Exp $
"""

import unittest

from zope.app import zapi
from zope.app.container.interfaces import IReadContainer
from sip.browser import api
from sip.ftests.base import Base

class TestPrincipalManage(Base):
    level = 2
    use_test_user = False

    def test_PrincipalView(self):
        principals = self.sip['principals']
        principal_count = len(principals)
        request = self.request
        form = request.form
        view = zapi.getView(self.sip, 'manage_principals.html', request)
        form['field.fullname'] = u'bob'
        form['field.username'] = u'bob'
        form['field.password'] = u'slacker'
        form['field.confirm_pass'] = u'slacker'
        form['ADD_PRINCIPAL'] = True
        form['UPDATE_SUBMIT'] = True
        view.update()
        self.failUnless(len(principals) == principal_count+1)
        del form['field.fullname']
        del form['field.username']
        del form['field.password']
        del form['field.confirm_pass']
        del form['ADD_PRINCIPAL']
        del form['UPDATE_SUBMIT']
        self.failUnless(view())

def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TestPrincipalManage))
    return suite

if __name__ == '__main__':
    unittest.main()
