##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
from unittest import TestSuite, main, makeSuite

from zope.app import zapi
from sip.ftests.base import Base

class TestSourceConstraints(Base):

    use_test_user = False

    def setUp(self):
        super(TestSourceConstraints, self).setUp()
        self.project = self._addProject(name='Foo')
        ctype = self._addContainerType()
        self.location = self._addLocation(type_id=ctype.id, name=u'location')
        self.location2 = self._addLocation(type_id=ctype.id, name=u'location2')
        self.project.valid_locations = [self.location.id]

    def test_constraints(self):
        p_source = zapi.traverse(self.sip, 'projects')
        l_source = zapi.traverse(self.project, 'locations')
        self.assertRaises(KeyError,
                          p_source.__getitem__,
                          'sip.Location.%d' % self.location2.id)
        self.assertRaises(KeyError,
                          l_source.__getitem__,
                          'sip.Location.%d' % self.location2.id)


def test_suite():
    return TestSuite((
        makeSuite(TestSourceConstraints),
        ))

if __name__=='__main__':
    main(defaultTest='test_suite')
