##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: test_technician.py,v 1.2 2005/10/21 00:11:35 dreamcatcher Exp $
"""

import unittest

from zope.app import zapi
from sip.ftests.base import Base

class TestTechnician(Base):
    level = 2
    def testAddTechnician(self):
        technicians = zapi.traverse(self.rootFolder, 'sip/technicians')
        self.assertEquals(len(technicians.keys()), 0)
        self._addTechnician()
        self.assertEquals(len(technicians.keys()), 1)

    def testAssignTechnician(self):
        technician = self._addTechnician()
        project = self._addProject()
        valid_technicians = project.valid_technicians
        self.assertEquals(len(valid_technicians), 0)
        project.valid_technicians = [technician.id]
        valid_technicians = project.valid_technicians
        self.assertEquals(len(valid_technicians), 1)

def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TestTechnician))
    return suite

if __name__ == '__main__':
    unittest.main()
