##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: test_tree.py,v 1.2 2005/10/21 00:11:35 dreamcatcher Exp $
"""

import unittest

from zope.app import zapi
from zope.app.container.interfaces import IReadContainer

from sip.ftests.base import Base


class TestTree(Base):
    level = 2
    use_test_user = False

    def _setup(self):
        self.project=self._addProject()
        ct = self._addContainerType()
        location=self._addLocation(ct.id)
        ct = self._addContainerType(root=False, name='box')
        self.container = self._addContainer(location,ct.id)
        self.project.valid_locations = [location.id]

    def testGenerateTree(self):
        self._setup()
        project = self.project
        request = self.request
        project = IReadContainer(project)
        locations = project['locationsproject']
        tree = zapi.getView(locations, 'container_tree.html', request)
        self.failUnless(tree())

    def testGenerateAddTree(self):
        self._setup()
        project = self.project
        request = self.request
        project = IReadContainer(project)
        locations = project['locationsproject']
        tree = zapi.getView(locations, 'container_add_tree.html', request)
        self.failUnless(tree())



def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TestTree))
    return suite

if __name__ == '__main__':
    unittest.main()
