##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: container.py,v 1.2 2005/10/21 00:11:35 dreamcatcher Exp $
"""

from zope.interface import Interface, Attribute
from zope.schema import TextLine, Int, Bool
from sip.fields import ContainerTypeField
from sip.interfaces import ISIPSchema, Unique, FieldFactory
from sip.descriptors import BoundCallableDescriptor
from sip.i18n import _
class IContainer(Interface):
    """Marker Container Interface"""

class IContainerSchema(ISIPSchema):
    """ """

    name = FieldFactory(
        TextLine,
        title=_('Container Name'),
        description=_('Container Description'),
        required=True,
        constraint=BoundCallableDescriptor(
        Unique(className='sip.Container', columnName='name'))
        )

    type_id = ContainerTypeField(
        title=_('Container Type'),
        description=_('Container Type Description'),
        required=True,
        vocabulary='sip.vocab.container_types')

    parent_id = Attribute('Parent Id')

    location_id = Attribute('Location Id')


class IContainerAddSchema(IContainerSchema):
    """ """

    rows = Int(title=_('Rows'),
               description=_('Number of rows'),
               required=False,
               default=1)
    columns = Int(title=_('Columns'),
                  description=u'Number of columns',
                  required=False,
                  default=1)
