##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: technician.py,v 1.2 2005/10/21 00:11:35 dreamcatcher Exp $
"""

from zope.interface import Attribute
from zope.schema import TextLine
from sip.i18n import _
from sip.interfaces import ISIPSchema, FieldFactory
from sip.descriptors import BoundCallableDescriptor
from sip.utils import Unique

class ITechnician(ISIPSchema):
    """ """

    name = Attribute('Name')

    username = FieldFactory(
        TextLine,
        title=_('Technician ID'),
        description=_(('The name used to identify this technician'
        'in the system, as well as for the technician to log in')),
        required=True,
        max_length=50,
        constraint=BoundCallableDescriptor(
        Unique(className='sip.Technician', columnName='technician_id'))
        )

    fullname = TextLine(title=_('Full Name'),
                        description=_('The technician full name'),
                        required=False,
                        max_length=255,
                        )
