##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: location.py,v 1.2 2005/10/21 00:08:11 dreamcatcher Exp $
"""

__metaclass__ = type

from datetime import date
from sqlobject import *
from sqlos import SQLOS

from zope.interface import implements
from zope.app import zapi
from zope.app.container.contained import Contained

from sip.interfaces.location import ILocation, ILocationSchema
from sip.browser import api

class Location(SQLOS, Contained):

    implements(ILocation, ILocationSchema)

    _idName='location_id'
    _columns = [
        StringCol('name', length=255, notNull=1),
        StringCol('building', length=255, notNull=0, default=''),
        StringCol('room', length=255, notNull=0, default=''),
        IntCol('temperature', notNull=0),
        DateCol('start_date', notNull=1,default=date.today),
        DateCol('end_date', notNull=0,default=None),
        StringCol('commit_message', notNull=1),
        ]

    def getRootContainer(self):
        factory = api.factory('sip.Container', context=self)
        query=('location_id=%d and parent_id=1'
                'and container.container_id=container_location.container_id')
        query = query % self.id
        result = factory.select(query, clauseTables=('container_location',))
        if result.count():
            return api.contained(result[0], self, name='.')
        return None

    def getRootId(self):
        """returns the container_id for the root container"""
        root = self.getRootContainer()
        return root.id
