##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: project.py,v 1.2 2005/10/21 00:08:11 dreamcatcher Exp $
"""

__metaclass__ = type

from datetime import date
from sqlobject import *
from sqlos import SQLOS

from zope.interface import implements
from zope.app import zapi
from zope.proxy import removeAllProxies
from zope.security.checker import NamesChecker

from sip.interfaces.project import IProject, IProjectSchema
from sip.browser import api
from sip.descriptors import ProjectRelationDescriptor
from sip.browser.admin import NextURLProxy
from sip.aliquot import Aliquot

from sqlos.interfaces.container \
     import ISQLObjectContainer

class Project(SQLOS):

    implements(IProject, IProjectSchema)

    _idName='project_id'
    _columns = [
        StringCol('name', length=255, notNull=1),
        StringCol('commit_message', notNull=1),
        DateCol('start_date', notNull=1, default=date.today),
        DateCol('end_date', notNull=0, default=None),
        BoolCol('require_commit_message', default=False, notNull=0),
        ]

    valid_locations = ProjectRelationDescriptor(
        'sip.LocationProject',
        'location_id')

    valid_technicians = ProjectRelationDescriptor(
        'sip.TechnicianProject',
        'technician_id')

    valid_sample_types = ProjectRelationDescriptor(
        'sip.SampleTypeProject',
        'sample_type_id')


class AddProject:

    def create(self, *args, **kw):
        factory = api.factory('sip.Project', context=self.context.context)
        return factory(**kw)

    def nextURL(self):
        return super(AddProject,self).nextURL() + '#add_project'
