##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: test_annotationprincipalrolemanager.py,v 1.2 2005/10/21 00:11:35 dreamcatcher Exp $
"""

__metaclass__ = type

import unittest

from transaction import get_transaction

from zope.app import zapi
from zope.app.tests import setup
from zope.configuration import xmlconfig
from zope.app.securitypolicy.tests.test_annotationprincipalrolemanager import Test as BaseTest
from zope.app.security.principalregistry import principalRegistry as pr
from sip.root import AppRoot
from sip.security.principalrole import SQLAnnotationPrincipalRoleManager
from sip.ftests.base import Base

class Test(BaseTest, Base):

    def setUp(self):
        Base.setUp(self)

    def _make_roleManager(self, obj=None):
        if obj is None:
            obj = zapi.traverse(self.sip, 'projects')
        return SQLAnnotationPrincipalRoleManager(obj)

    def tearDown(self):
        Base.tearDown(self)
        try:
            principal =  pr._PrincipalRegistry__principalsByLogin['APrincipal']
        except KeyError:
            pass
        else:
            del pr._PrincipalRegistry__principalsByLogin[principal.getLogin()]
            del pr._PrincipalRegistry__principalsById[principal.id]
        try:
            principal =  pr._PrincipalRegistry__principalsByLogin['Principal 2']
        except KeyError:
            pass
        else:
            del pr._PrincipalRegistry__principalsByLogin[principal.getLogin()]
            del pr._PrincipalRegistry__principalsById[principal.id]
        from sip.security.source import securityCache
        securityCache.clear()
        from sip.security.principalrole import securityCache
        securityCache.clear()

def test_suite():
    loader=unittest.TestLoader()
    return loader.loadTestsFromTestCase(Test)

if __name__=='__main__':
    unittest.TextTestRunner().run(test_suite())
