##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
from zope.interface import implements
from sip.interfaces.services import IGlobalAppContainerRegistry

class GlobalAppContainerRegistry:

    implements(IGlobalAppContainerRegistry)

    def __init__(self):
        self.__registry = {}

    def registerContainer(self, klass, name=''):
        """ See IGlobalProjectService interface """
        if not name:
            name = "%s" % klass.__name__
        self.__registry[name] = klass

    def queryContainers(self, context=None):
        """ See IGlobalProjectService interface """
        containers = {}
        for name, klass in self.__registry.iteritems():
            containers[name] = klass(context=context)
        return containers

    def getNames(self):
        """ See IGlobalProjectService interface """
        return self.__registry.keys()

service = GlobalAppContainerRegistry()
queryContainers = service.queryContainers
registerContainer = service.registerContainer
