##############################################################################
#
# SIP - Sample Inventory Program
# Copyright (C) 2005 RUNYAGA LLC and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: direction.py,v 1.2 2005/10/21 00:15:20 dreamcatcher Exp $
"""

from zope.interface import implements

from sip.source.utility import UtilityContainer
from sip.shipment.interfaces import IShipmentDirection
from sip.shipment.interfaces import IIncomingShipmentState
from sip.shipment.interfaces import IOutgoingShipmentState
from sip.interfaces import INolinkBreadcrumb
from sip.i18n import _

class Incoming(UtilityContainer):

    implements(IShipmentDirection)
    interface = IIncomingShipmentState
    name = _('Incoming Shipments')

class Outgoing(UtilityContainer):

    implements(IShipmentDirection, INolinkBreadcrumb)
    interface = IOutgoingShipmentState
    name = _('Outgoing Shipments')
